﻿Imports System.Drawing
Imports System.Drawing.Drawing2D
Public Class Form1

    Dim Packman As Label
    Dim Minotavrs(2) As Label
    Dim finAL As Boolean = False
    Dim Label1, Label2 As Label

    Dim timer1 As Timer
    Dim date1 As DateTime

    Dim bmp As New Bitmap(Me.Width, Me.Height)
    Dim g As Graphics
    'для хранения точки, в которой есть как минимум два альтернативных хода
    Dim alternativePoint As Point

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Pack_Init()
        Minotavrs_Init()

        Label1 = New Label()
        With Label1
            .Location = New Point(240, 10)
            .TextAlign = ContentAlignment.MiddleCenter
            .BorderStyle = BorderStyle.Fixed3D
            .Width = 50
            .BackColor = Color.Gray
            .Height = 20
            .ForeColor = Color.Black
            .Font = New Font("Arial", 9)
            .Text = "Start"

        End With
        AddHandler Label1.Click, AddressOf Label1_Click
        Me.Controls.Add(Label1)
        Label2 = New Label()
        With Label2
            .Location = New Point(240, 30)
            .Text = "New" & vbNewLine & "Game"
            .TextAlign = ContentAlignment.MiddleCenter
            .BorderStyle = BorderStyle.Fixed3D
            .BackColor = Color.Gray
            .Width = 50
            .Height = 40
            .ForeColor = Color.Black
            .Font = New Font("Arial", 9)
        End With
        AddHandler Label2.Click, AddressOf Label2_Click
        Me.Controls.Add(Label2)
        timer1 = New Timer()
        timer1.Interval = 250
        AddHandler timer1.Tick, AddressOf timer1_Tick
        Me.Text = "Пакман против минотавров"


    End Sub

    'отрисовка лабиринта
    Private Sub Lab_Draw()

        g = Graphics.FromImage(bmp)
        g.FillRectangle(Brushes.Black, 20, 10, 220, 20)
        g.FillRectangle(Brushes.Black, 20, 110, 220, 20)
        g.FillRectangle(Brushes.Black, 20, 210, 220, 20)
        g.FillRectangle(Brushes.Black, 80, 30, 20, 220)
        g.FillRectangle(Brushes.Black, 160, 30, 20, 220)
        g.FillRectangle(Brushes.Red, 240, 210, 20, 20)
        g.DrawImage(bmp, New Point(0, 0))
        g.Dispose()
        Me.BackgroundImage = bmp

    End Sub

    Private Sub Form1_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Lab_Draw()
    End Sub
    'Создаем движущуюся метку
    Private Sub Pack_Init()
        Packman = New Label()
        With Packman
            .Height = 20
            .Width = 20
            .Location = New Point(20, 10)
            .BackColor = Color.Transparent
            .Enabled = False
            .Image = Image.FromFile("img/P2.png")
        End With
        AddHandler Packman.Move, AddressOf Pack_GetPosition
        Me.Controls.Add(Packman)
    End Sub

    'Создаем минотавров, которые будут ловить пакмана
    Private Sub Minotavrs_Init()
        Dim x As Integer
        Static rnd As Random = New Random()
        For i As Byte = 0 To 2
            Minotavrs(i) = New Label()
            x = rnd.Next(20, 220)
            With Minotavrs(i)
                .Height = 20
                .Width = 20
                .Location = New Point(x - (x Mod 20), 10 + i * 100)
                .BackColor = Color.Transparent
                .Enabled = False
                .Image = Image.FromFile("img/P3.png")
            End With
            Me.Controls.Add(Minotavrs(i))
        Next
    End Sub

    Private Sub Pack_GetPosition(sender As Object, e As EventArgs)
        'текущее местонахождение
        Dim currentPosition As Point = CType(sender, Label).Location

        If currentPosition = New Point(220, 210) Then
            timer1.Stop()
            Packman.Enabled = False
            MessageBox.Show("Congratulations! You are the winnner!" & vbNewLine & "Your time :" & Label1.Text)
            Label1.Text = "Start"
            date1 = Nothing
            g = Me.CreateGraphics()
            g.DrawString("Hoorah! You are the winnner!", New Font("Arial", 14), Brushes.Red, New PointF(10, 120))
            Dispose_Labels()
            g.Dispose()
        End If

    End Sub

    Private Sub Min_GetPosition(ByVal Minotavr As Label)
        'Randomize()
        Static rnd = New Random()
        'приращение
        Dim inc As Integer = rnd.Next(-2, 2)

        Dim c As Color
        'если приращение по оси х меньше 0 - тогда движение влево
        If inc = -1 Then
            c = bmp.GetPixel(Minotavr.Left - 1, Minotavr.Top + 10)
            If (c = Color.FromArgb(255, 0, 0, 0)) Then
                Minotavr.Left -= 20
            End If
            'если больше 0 - т.е. =1, то движение вправо
        ElseIf inc = 1 Then

            c = bmp.GetPixel(Minotavr.Left + 21, Minotavr.Top + 10)
            If (c = Color.FromArgb(255, 0, 0, 0)) Then
                Minotavr.Left += 20
            End If
            'есди равно нулю - движение по вертикали
        Else
            inc = rnd.Next(-2, 2)
            'если -1 - движение вверх
            If inc = -1 Then
                c = bmp.GetPixel(Minotavr.Left + 10, Minotavr.Top - 1)
                If (c = Color.FromArgb(255, 0, 0, 0)) Then
                    Minotavr.Top -= 20
                End If
                'иначе - движение вниз
            ElseIf inc = 1 Then

                c = bmp.GetPixel(Minotavr.Left + 10, Minotavr.Top + 21)
                If (c = Color.FromArgb(255, 0, 0, 0)) Then
                    Minotavr.Top += 20
                End If
            End If

        End If

    End Sub
    Private Sub Form1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        If Packman.Enabled = True Then
            Dim c As Color
            Select Case e.KeyCode
                Case Keys.Down

                    c = bmp.GetPixel(Packman.Left + 10, Packman.Top + 21)
                    If (c = Color.FromArgb(255, 0, 0, 0)) Then
                        Packman.Top += 20
                    End If
                    Return
                Case Keys.Up
                    c = bmp.GetPixel(Packman.Left + 10, Packman.Top - 1)
                    If (c = Color.FromArgb(255, 0, 0, 0)) Then
                        Packman.Top -= 20
                    End If
                    Return
                Case Keys.Left
                    c = bmp.GetPixel(Packman.Left - 1, Packman.Top + 10)
                    If (c = Color.FromArgb(255, 0, 0, 0)) Then
                        Packman.Left -= 20
                    End If
                    Return
                Case Keys.Right
                    c = bmp.GetPixel(Packman.Left + 21, Packman.Top + 10)
                    If (c = Color.FromArgb(255, 0, 0, 0)) Then
                        Packman.Left += 20
                        'Packman.Image.RotateFlip(RotateFlipType.RotateNoneFlipX)
                    End If
                    Return
            End Select
        End If
    End Sub

    Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs)
        Label1.Text = DateTime.Now.Subtract(date1).Seconds & "." & DateTime.Now.Subtract(date1).Milliseconds
        Array.ForEach(Of Label)(Minotavrs, AddressOf Min_GetPosition)
        Kabsdetc()
    End Sub

    Private Sub Label1_Click(ByVal sender As Object, ByVal e As EventArgs)
        Packman.Enabled = True
        Array.ForEach(Of Label)(Minotavrs, Sub(m) m.Enabled = True)
        date1 = DateTime.Now
        timer1.Start()
    End Sub
    Private Sub Label2_Click(ByVal sender As Object, ByVal e As EventArgs)
        If finAL = True Then
            Me.Invalidate()
            Me.Refresh()
            Pack_Init()
            Minotavrs_Init()
        End If
    End Sub

    'пересечение пакмана и минотавров
    Private Sub Kabsdetc()
        Array.ForEach(Of Label)(Minotavrs, Sub(m)
                                               If m.Left + m.Width > Packman.Left AndAlso Packman.Left + Packman.Width > m.Left _
                                                   AndAlso m.Top + m.Height > Packman.Top AndAlso m.Top < Packman.Top + Packman.Height Then
                                                   timer1.Stop()
                                                   Packman.Enabled = False
                                                   Label1.Text = "Start"
                                                   date1 = Nothing
                                                   g = Me.CreateGraphics()
                                                   g.DrawString("Ha ha! You are LOOSER!!!", New Font("Arial", 14), Brushes.Blue, New PointF(10, 120))
                                                   g.Dispose()
                                                   Dispose_Labels()
                                               End If
                                           End Sub)
    End Sub

    Private Sub Dispose_Labels()
        Array.ForEach(Of Label)(Minotavrs, Sub(k)
                                               Packman.Dispose()
                                               k.Dispose()
                                           End Sub)
        finAL = True
    End Sub

End Class